//-------------------------------------------------------------------------------------------------+
// * @file  MessageReceiver.h
// * @brief receive message (string data) and display it on console.
//-------------------------------------------------------------------------------------------------+

#ifndef MESSAGERECEIVER_H
#define MESSAGERECEIVER_H

#include <rtm/Manager.h>
#include <rtm/DataFlowComponentBase.h>
#include <rtm/CorbaPort.h>
#include <rtm/DataInPort.h>
#include <rtm/DataOutPort.h>
#include <rtm/idl/BasicDataTypeSkel.h>
#include <rtm/idl/ExtendedDataTypesSkel.h>
#include <rtm/idl/InterfaceDataTypesSkel.h>

using namespace RTC;


//-------------------------------------------------------------------------------------------------+
// * @class MessageReceiver
// * @brief receive message (string data) and display it on console.
//-------------------------------------------------------------------------------------------------+
class MessageReceiver : public RTC::DataFlowComponentBase{

public:
	MessageReceiver(RTC::Manager* manager);
	~MessageReceiver();
	virtual RTC::ReturnCode_t onInitialize();
	virtual RTC::ReturnCode_t onExecute(RTC::UniqueId ec_id);

protected:

	// DataInPort declaration
	TimedString m_message;
	InPort<TimedString> m_messageIn;
};



//-------------------------------------------------------------------------------------------------+
extern "C"
{
  DLL_EXPORT void MessageReceiverInit(RTC::Manager* manager);
};

#endif // MESSAGERECEIVER_H
